## rr 1.0

=== DESCRIPTION ===
Package: rr
Version: 1.0
Date: 2015-2-7
Title: Statistical Methods for the Randomized Response Technique
Author: Graeme Blair <graeme.blair@columbia.edu>, Yang-Yang Zhou <yz3@princeton.edu>, Kosuke Imai <kimai@princeton.edu>
Maintainer: Graeme Blair <graeme.blair@columbia.edu>
Depends: R (>= 3.0.0), utils
Imports: MASS (>= 7.3), arm (>= 1.7-07), coda (>= 0.16-1)
Description: Enables researchers to conduct multivariate statistical analyses of survey data with randomized response technique items from several designs, including mirrored question, forced question, and unrelated question. This includes regression with the randomized response as the outcome and logistic regression with the randomized response item as a predictor. In addition, tools for conducting power analysis for designing randomized response items are included. The package implements methods described in Blair, Imai, and Zhou (2015) ''Design and Analysis of the Randomized Response Technique,'' Working paper available at <http://graemeblair.com/papers/randresp.pdf>.
LazyLoad: yes
LazyData: yes
License: GPL (>= 2)
Packaged: 2015-02-07 10:50:30 UTC; gblair
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2015-02-08 01:05:46

## rr 1.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: rr
-Version: 1.0
-Date: 2015-2-7
+Version: 1.1
+Date: 2015-2-19
 Title: Statistical Methods for the Randomized Response Technique
 Author: Graeme Blair <graeme.blair@columbia.edu>, Yang-Yang Zhou <yz3@princeton.edu>, Kosuke Imai <kimai@princeton.edu>
 Maintainer: Graeme Blair <graeme.blair@columbia.edu>
@@ -10,7 +10,7 @@
 LazyLoad: yes
 LazyData: yes
 License: GPL (>= 2)
-Packaged: 2015-02-07 10:50:30 UTC; gblair
+Packaged: 2015-02-19 03:33:42 UTC; gblair
 NeedsCompilation: yes
 Repository: CRAN
-Date/Publication: 2015-02-08 01:05:46
+Date/Publication: 2015-02-19 08:01:47

## rr 1.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: rr
-Version: 1.1
-Date: 2015-2-19
+Version: 1.2
+Date: 2015-3-9
 Title: Statistical Methods for the Randomized Response Technique
 Author: Graeme Blair <graeme.blair@columbia.edu>, Yang-Yang Zhou <yz3@princeton.edu>, Kosuke Imai <kimai@princeton.edu>
 Maintainer: Graeme Blair <graeme.blair@columbia.edu>
@@ -10,7 +10,8 @@
 LazyLoad: yes
 LazyData: yes
 License: GPL (>= 2)
-Packaged: 2015-02-19 03:33:42 UTC; gblair
+Suggests: testthat
+Packaged: 2015-03-21 16:04:03 UTC; gblair
 NeedsCompilation: yes
 Repository: CRAN
-Date/Publication: 2015-02-19 08:01:47
+Date/Publication: 2015-03-21 19:28:56

## rr 1.3

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: rr
-Version: 1.2
-Date: 2015-3-9
+Version: 1.3
+Date: 2015-3-25
 Title: Statistical Methods for the Randomized Response Technique
 Author: Graeme Blair <graeme.blair@columbia.edu>, Yang-Yang Zhou <yz3@princeton.edu>, Kosuke Imai <kimai@princeton.edu>
 Maintainer: Graeme Blair <graeme.blair@columbia.edu>
@@ -11,7 +11,7 @@
 LazyData: yes
 License: GPL (>= 2)
 Suggests: testthat
-Packaged: 2015-03-21 16:04:03 UTC; gblair
+Packaged: 2015-03-26 15:39:10 UTC; gblair
 NeedsCompilation: yes
 Repository: CRAN
-Date/Publication: 2015-03-21 19:28:56
+Date/Publication: 2015-03-26 17:50:33

## rr 1.3.1

=== DESCRIPTION ===
Package: rr
Version: 1.3.1
Date: 2016-5-13
Title: Statistical Methods for the Randomized Response Technique
Author: Graeme Blair <graeme.blair@columbia.edu>, Yang-Yang Zhou
    <yz3@princeton.edu>, Kosuke Imai <kimai@princeton.edu>
Maintainer: Graeme Blair <graeme.blair@columbia.edu>
Depends: R (>= 3.0.0), utils
Imports: MASS, arm, coda
Description: Enables researchers to conduct multivariate statistical analyses
    of survey data with randomized response technique items from several designs,
    including mirrored question, forced question, and unrelated question. This
    includes regression with the randomized response as the outcome and logistic
    regression with the randomized response item as a predictor. In addition,
    tools for conducting power analysis for designing randomized response items
    are included. The package implements methods described in Blair, Imai, and Zhou
    (2015) ''Design and Analysis of the Randomized Response Technique,'' Working
    paper available at <http://graemeblair.com/papers/randresp.pdf>.
LazyLoad: yes
LazyData: yes
License: GPL (>= 3)
Suggests: testthat
RoxygenNote: 5.0.1
NeedsCompilation: yes
Packaged: 2016-05-15 07:40:49 UTC; ligges
Repository: CRAN
Date/Publication: 2016-05-15 09:40:49

## rr 1.4

=== DESCRIPTION ===
Package: rr
Version: 1.4
Date: 2016-8-15
Title: Statistical Methods for the Randomized Response Technique
Author: Graeme Blair [aut, cre], Yang-Yang Zhou [aut, cre], 
    Kosuke Imai [aut, cre], Winston Chou [ctb]
Maintainer: Graeme Blair <graeme.blair@ucla.edu>
Depends: R (>= 3.0.0), utils
Imports: MASS, arm, coda, magic
Description: Enables researchers to conduct multivariate statistical analyses
    of survey data with randomized response technique items from several designs,
    including mirrored question, forced question, and unrelated question. This
    includes regression with the randomized response as the outcome and logistic
    regression with the randomized response item as a predictor. In addition,
    tools for conducting power analysis for designing randomized response items
    are included. The package implements methods described in Blair, Imai, and Zhou
    (2015) ''Design and Analysis of the Randomized Response Technique,'' Journal
    of the American Statistical Association 
    <http://graemeblair.com/papers/randresp.pdf>.
LazyLoad: yes
LazyData: yes
License: GPL (>= 3)
Suggests: testthat
RoxygenNote: 5.0.1
NeedsCompilation: yes
Packaged: 2016-08-16 01:24:11 UTC; gblair
Repository: CRAN
Date/Publication: 2016-08-17 00:49:19

## rr 1.4.1

=== DESCRIPTION ===
Package: rr
Version: 1.4.1
Title: Statistical Methods for the Randomized Response Technique
Authors@R: c(person("Graeme", "Blair", email = "graeme.blair@gmail.com", role = c("aut", "cre")),
             person("Yang-Yang", "Zhou", email = "yangyang.zhou@ubc.ca", role = c("aut")),
             person("Kosuke", "Imai", email = "imai@harvard.edu", role = c("aut")),
             person("Winston", "Chou", email = "wchou@princeton.edu", role = c("ctb")))
Depends: R (>= 3.0.0), utils
Imports: MASS, arm, coda, magic
Description: Enables researchers to conduct multivariate statistical analyses
    of survey data with randomized response technique items from several designs,
    including mirrored question, forced question, and unrelated question. This
    includes regression with the randomized response as the outcome and logistic
    regression with the randomized response item as a predictor. In addition,
    tools for conducting power analysis for designing randomized response items
    are included. The package implements methods described in Blair, Imai, and Zhou
    (2015) ''Design and Analysis of the Randomized Response Technique,'' Journal
    of the American Statistical Association 
    <https://graemeblair.com/papers/randresp.pdf>.
LazyLoad: yes
LazyData: yes
License: GPL (>= 3)
Suggests: testthat
Encoding: UTF-8
RoxygenNote: 7.1.2
NeedsCompilation: yes
Packaged: 2022-05-24 02:06:48 UTC; gdblair
Author: Graeme Blair [aut, cre],
  Yang-Yang Zhou [aut],
  Kosuke Imai [aut],
  Winston Chou [ctb]
Maintainer: Graeme Blair <graeme.blair@gmail.com>
Repository: CRAN
Date/Publication: 2022-05-24 10:10:02 UTC

## rr 1.4.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Package: rr
-Version: 1.4.1
+Version: 1.4.2
 Title: Statistical Methods for the Randomized Response Technique
 Authors@R: c(person("Graeme", "Blair", email = "graeme.blair@gmail.com", role = c("aut", "cre")),
              person("Yang-Yang", "Zhou", email = "yangyang.zhou@ubc.ca", role = c("aut")),
@@ -22,13 +22,13 @@
 License: GPL (>= 3)
 Suggests: testthat
 Encoding: UTF-8
-RoxygenNote: 7.1.2
+RoxygenNote: 7.2.3
 NeedsCompilation: yes
-Packaged: 2022-05-24 02:06:48 UTC; gdblair
+Packaged: 2024-01-16 06:17:35 UTC; gblair
 Author: Graeme Blair [aut, cre],
   Yang-Yang Zhou [aut],
   Kosuke Imai [aut],
   Winston Chou [ctb]
 Maintainer: Graeme Blair <graeme.blair@gmail.com>
 Repository: CRAN
-Date/Publication: 2022-05-24 10:10:02 UTC
+Date/Publication: 2024-01-16 11:20:02 UTC

## rr 2.0.0

=== CMakeLists.txt ===
# *-* Mode: cmake; *-*

cmake_minimum_required(VERSION 2.8.5)
project(rr C CXX ASM)

enable_testing()
set(BUILD_SHARED_LIBS ON)

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# CAREFUL!  "-" is an invalid character in RPM package names, while
# debian is happy with it.  However, "_" is illegal in debs, while RPM
# is cool with it.  Sigh.
set(rr_VERSION_MAJOR 2)
set(rr_VERSION_MINOR 0)
set(rr_VERSION_PATCH 0)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -O0 -g3 -Wall -Werror -m32 -Wstrict-prototypes")
# Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
# Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++0x -pthread -O0 -g3 -Wall -Werror -m32")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3 -m32")

set_source_files_properties(src/preload/preload.c PROPERTIES COMPILE_FLAGS -O2)

# Disable PIC.
string(REGEX REPLACE "-fPIC" ""
  CMAKE_SHARED_LIBRARY_C_FLAGS "${CMAKE_SHARED_LIBRARY_C_FLAGS}")

include_directories("${PROJECT_SOURCE_DIR}/include")

add_library(rrpreload
  src/preload/preload.c
  src/preload/traced_syscall.S
  src/preload/untraced_syscall.S
  src/preload/vsyscall_hook.S
)

add_executable(rr
  src/test/cpuid_loop.S
  src/compressed_io.cc
  src/debugger_gdb.cc
  src/diverter.cc
  src/emufs.cc
  src/event.cc
  src/hpc.cc
  src/main.cc
  src/recorder.cc
  src/recorder_sched.cc
  src/record_signal.cc
  src/record_syscall.cc
  src/registers.cc
  src/remote_syscalls.cc
  src/replayer.cc
  src/replay_syscall.cc
  src/session.cc
  src/syscalls.cc
  src/task.cc
  src/trace.cc
  src/util.cc
  src/vm.cc
)

target_link_libraries(rr
  -ldl
  -lrt
  -lz
)

target_link_libraries(rrpreload
  -ldl
)

install(PROGRAMS scripts/signal-rr-recording.sh
  DESTINATION bin)

install(TARGETS rr rrpreload
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)

##--------------------------------------------------
## Testing

# A "basic test" consists of a foo.c source file. All basic tests use the
# same basic_test.run driver script. The test name is passed as an additional
# parameter to the driver script. This script just does
# "compare_test EXIT-SUCCESS", i.e. records and replays the program and verifies
# that the output of both runs is identical and contains EXIT-SUCCESS.
#
# NB: you must update this variable when adding a new test source
# file.  The list is not generated automatically.
#
# Alphabetical, please.
set(BASIC_TESTS
  64bit_child
  accept
  at_threadexit
  bad_ip
  barrier
  big_buffers
  block
  chew_cpu
  clock
  clone
  desched_blocking_poll
  epoll_create
  epoll_create1
  exec_self
  fadvise
  fault_in_code_page
  fcntl_owner_ex
  flock
  fork_child_crash
  fork_stress
  fxregs
  getgroups
  getsid
  grandchild_threads
  grandchild_threads_main_running
  grandchild_threads_thread_running
  grandchild_threads_parent_alive
  int3
  intr_futex_wait_restart
  intr_poll
  intr_read_no_restart
  intr_read_restart
  intr_sleep
  intr_sleep_no_restart
  io
  madvise
  map_fixed
  mmap_discontinuous
  mmap_private
  mmap_ro
  mmap_shared
  mmap_shared_subpage
  mmap_short_file
  mmap_tmpfs
  mprotect
  mprotect_heterogenous
  mprotect_stack
  mremap
  msg
  msync
  munmap_discontinuous
  no_mask_timeslice
  orphan_process
  pause
  perf_event
  poll_sig_race
  prctl
  prctl_name
  prw
  pthread_condvar_locking
  rdtsc
  save_data_fd
  sched_setaffinity
  sched_yield
  sched_yield_to_lower_priority
  scm_rights
  sendfile
  setsid
  sigchld_interrupt_signal
  sigprocmask
  sigqueueinfo
  sigrt
  sigtrap
  simple
  sioc
  splice
  statfs
  strict_priorities
  switch_read
  syscallbuf_timeslice
  sysconf
  sysctl
  sysemu_singlestep
  tcgets
  tgkill
  thread_stress
  timerfd
  tiocgwinsz
  truncate
  uname
  unjoined_thread
  wait
  write_race
)

# A "test with program" consists of a foo.c source file and a foo.run driver
# script.  See src/test/util.sh to learn how the .run files work.
#
# NB: you must update this variable when adding a new test source
# file.  The list is not generated automatically.
#
# Alphabetical, please.
set(TESTS_WITH_PROGRAM
  abort_nonmain
  alarm
  args
  async_kill_with_threads
  async_kill_with_threads_main_running
  async_kill_with_threads_thread_running
  async_segv
  async_signal_syscalls
  async_signal_syscalls_siginfo
  async_usr1
  bad_syscall
  block_intr_sigchld
  breakpoint
  breakpoint_overlap
  call_function
  condvar_stress
  crash
  exit_group
  exit_status
  explicit_checkpoints
  fork_syscalls
  getcwd
  goto_event
  hello
  ignored_async_usr1
  immediate_restart
  interrupt
  intr_ptrace_decline
  link
  mmap_write
  mutex_pi_stress
  nanosleep
  priority
  ptrace
  read_big_struct
  segfault
  sigill
  step_thread
  target_fork
  target_process
  term_nonmain
  threaded_syscall_spam
  threads
  tiocinq
  user_ignore_sig
  vfork
  watchpoint
)

# A "test without program" is a foo.run driver script only, which does
# something with one of the test executables above (or has special rules
# to build its own executable).
#
# NB: you must update this variable when adding a new test source
# file.  The list is not generated automatically.
#
# Alphabetical, please.
set(TESTS_WITHOUT_PROGRAM
  async_signal_syscalls_100
  async_signal_syscalls_1000
  bad_breakpoint
  break_block
  break_clock
  break_clone
  break_exec
  break_int3
  break_mmap_private
  break_msg
  break_ptrace
  break_rdtsc
  break_sigreturn
  break_sync_signal
  break_thread
  break_time_slice
  checkpoint_async_signal_syscalls_1000
  checkpoint_mmap_shared
  checkpoint_prctl_name
  checkpoint_simple
  cont_signal
  cpuid
  dead_thread_target
  deliver_async_signal_during_syscalls
  env_newline
  execp
  explicit_checkpoint_clone
  fork_exec_info_thr
  get_thread_list
  parent_no_break_child_bkpt
  parent_no_stop_child_crash
  read_bad_mem
  remove_watchpoint
  restart_unstable
  restart_diversion
  sanity
  signal_stop
  step1
  step_signal
  subprocess_exit_ends_session
  syscallbuf_timeslice_250
  trace_version
  term_trace_cpu
  term_trace_syscall
)

# An "other test" is a test which doesn't have its own driver script but
# needs its own rules for building an executable so can't be in BASIC_TESTS.
#
# NB: you must update this variable when adding a new test source
# file.  The list is not generated automatically.
#
# Alphabetical, please.
set(OTHER_TESTS
  sigreturn
)

foreach(test ${BASIC_TESTS} ${TESTS_WITH_PROGRAM})
  add_executable(${test} src/test/${test}.c)
  target_link_libraries(${test} -lrt)
endforeach(test)

# cpuid test needs to link with cpuid_loop.S
add_executable(cpuid src/test/cpuid.c src/test/cpuid_loop.S)
target_link_libraries(cpuid -lrt)

# sigreturn test needs to link with sigreturn_helper.S
add_executable(sigreturn src/test/sigreturn.c src/test/sigreturn_helper.S)
target_link_libraries(sigreturn -lrt)

foreach(test ${BASIC_TESTS} ${OTHER_TESTS})
  add_test(${test}
    bash ${CMAKE_SOURCE_DIR}/src/test/basic_test.run -b ${PROJECT_BINARY_DIR} ${test})
  set_tests_properties(${test}
    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")

  add_test(${test}-no-syscallbuf
    bash ${CMAKE_SOURCE_DIR}/src/test/basic_test.run -n ${PROJECT_BINARY_DIR} ${test})
  set_tests_properties(${test}-no-syscallbuf
    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
endforeach(test)

foreach(test ${TESTS_WITH_PROGRAM} ${TESTS_WITHOUT_PROGRAM})
  add_test(${test}
    bash ${CMAKE_SOURCE_DIR}/src/test/${test}.run -b ${PROJECT_BINARY_DIR})
  set_tests_properties(${test}
    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")

  add_test(${test}-no-syscallbuf
    bash ${CMAKE_SOURCE_DIR}/src/test/${test}.run -n ${PROJECT_BINARY_DIR})
  set_tests_properties(${test}-no-syscallbuf
    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
endforeach(test)

include(ProcessorCount)
ProcessorCount(N)
if(NOT N EQUAL 0)
  set(JFLAG -j${N})
endif()

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --verbose ${JFLAG})

##--------------------------------------------------
## Package configuration

include (InstallRequiredSystemLibraries)

set(CPACK_PACKAGE_NAME "rr")
set(CPACK_PACKAGE_VERSION_MAJOR "${rr_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${rr_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${rr_VERSION_PATCH}")
set(CPACK_SYSTEM_NAME "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")

set(CPACK_OUTPUT_FILE_PREFIX dist)
set(CPACK_GENERATOR "TGZ;RPM;DEB")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_BINARY_DIR "${PROJECT_BINARY_DIR}")
set(CPACK_STRIP_FILES TRUE)

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY
  "Lightweight tool for recording and replaying execution of applications (trees of processes and threads)")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_PACKAGE_VENDOR "Mozilla Foundation")

set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Mozilla Foundation")
set(CPACK_DEBIAN_PACKAGE_SECTION "devel")

# XXX Cmake 2.8.7 doesn't know how to avoid specifiying /usr,
# /usr/bin, etc, as files to be installed, but distros are finicky
# about their specification.  We want to manually filter those paths
# out of our install list but 2.8.7 also isn't capable of that.
set(CPACK_RPM_USER_BINARY_SPECFILE "${CMAKE_SOURCE_DIR}/rr.spec")
set(CPACK_RPM_PACKAGE_RELEASE 1)
set(CPACK_RPM_PACKAGE_GROUP "Development/Debuggers")
set(CPACK_RPM_PACKAGE_LICENSE "MIT and BSD")

include (CPack)

##--------------------------------------------------
## Misc

add_custom_target(setup-travis COMMAND src/script/setup_travis.sh)

=== debian/changelog ===
rr (2.0.0-1) unstable; urgency=medium

  * New upstream release.
  * doc/rr.pdf is no longer shipped upstream, there is no need to filter
    it in debian/copyright.
  * Westmere and Haswell support is no longer experimental, update the
    description accordingly.
  * rr now needs zlib to build.
  * Add bash-location.patch to fix the bash location in signal-rr-
    recording.sh.
  * Install signal-rr-recording.sh as signal-rr-recording.

 -- Stephen Kitt <skitt@debian.org>  Tue, 09 Sep 2014 00:15:39 +0200

rr (1.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 13 Aug 2014 00:02:14 +0200

rr (1.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Tue, 12 Aug 2014 23:57:01 +0200

rr (1.3.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sun, 04 May 2014 20:52:07 +0200

rr (1.2.1+dfsg-1) unstable; urgency=low

  * Initial release (closes: #742556).

 -- Stephen Kitt <skitt@debian.org>  Fri, 18 Apr 2014 06:43:45 +0200

=== debian/control ===
Source: rr
Section: devel
Priority: optional
Maintainer: Stephen Kitt <skitt@debian.org>
Build-Depends:
 autotools-dev,
 cmake,
 debhelper (>= 9),
 libdisasm-dev,
 libpfm4-dev,
 zlib1g-dev,
# The following are required for the test suite
# python-pexpect,
# realpath
Standards-Version: 3.9.5
Homepage: http://rr-project.org
Vcs-Git: git://anonscm.debian.org/collab-maint/rr.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/rr.git;a=summary

Package: rr
Architecture: i386
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: application execution recorder, player and debugger
 rr allows application executions to be recorded and then replayed
 with gdb as many times as desired.
 .
 This allows intermittent, or complex to reproduce, bugs to be
 captured and then debugged at leisure. Replays are deterministic,
 always identical from one run to another.
 .
 rr is incompatible with ptrace hardening, and currently only supports
 Intel Nehalem, Westmere, Sandy Bridge, Ivy Bridge and Haswell CPUs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS += -O-Bbuild

override_dh_auto_configure:
	rm -f configure
	dh_auto_configure

override_dh_auto_test:
# Tests are disabled since they only work on supported CPUs
# (Intel Merom, Nehalem, Sandy Bridge and Ivy Bridge)

override_dh_auto_install:
	dh_auto_install
	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording

%:
	dh $@  --with autotools-dev

## rr 3.0.0

=== CMakeLists.txt ===
# *-* Mode: cmake; *-*

cmake_minimum_required(VERSION 2.8.5)
project(rr C CXX ASM)

enable_testing()
set(BUILD_SHARED_LIBS ON)

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# CAREFUL!  "-" is an invalid character in RPM package names, while
# debian is happy with it.  However, "_" is illegal in debs, while RPM
# is cool with it.  Sigh.
set(rr_VERSION_MAJOR 3)
set(rr_VERSION_MINOR 0)
set(rr_VERSION_PATCH 0)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -O0 -g3 -Wall -Werror -Wstrict-prototypes")
# Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
# Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++0x -pthread -O0 -g3 -Wall -Werror")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")

option(force32bit, "Force a 32-bit build, rather than a 64-bit one")
if(force32bit)
  set(rr_64BIT false)
  set(rr_MBITNESS_OPTION -m32)
else()
  if (CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(rr_64BIT true)
  else()
    set(rr_64BIT false)
  endif()
  set(rr_MBITNESS_OPTION)
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${rr_MBITNESS_OPTION}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${rr_MBITNESS_OPTION}")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} ${rr_MBITNESS_OPTION}")

set_source_files_properties(src/preload/preload.c PROPERTIES COMPILE_FLAGS -O2)

include_directories("${PROJECT_SOURCE_DIR}/include")
# We need to know where our generated files are.
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

add_library(rrpreload
  src/preload/preload.c
  src/preload/traced_syscall.S
  src/preload/untraced_syscall.S
  src/preload/syscall_hook.S
)

# Ensure that CMake knows about our generated files.
#
# Alphabetical, please.
set(GENERATED_FILES
  AssemblyTemplates.generated
  CheckSyscallNumbers.generated
  IsAlwaysEmulatedSyscall.generated
  SyscallDefsTable.generated
  SyscallEnumsX64.generated
  SyscallEnumsX86.generated
  SyscallHelperFunctions.generated
  SyscallnameArch.generated
  SyscallRecordCase.generated
)

foreach(generated_file ${GENERATED_FILES})
  set_source_files_properties(${generated_file}
                              PROPERTIES GENERATED true HEADER_FILE_ONLY true)
  add_custom_command(OUTPUT ${generated_file}
                     COMMAND python "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
		               "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
		     DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
		       "${CMAKE_CURRENT_SOURCE_DIR}/src/syscalls.py"
		       "${CMAKE_CURRENT_SOURCE_DIR}/src/assembly_templates.py")
endforeach(generated_file)

add_executable(rr
  ${GENERATED_FILES}
  src/test/cpuid_loop.S
  src/AddressSpace.cc
  src/AutoRemoteSyscalls.cc
  src/Command.cc
  src/CompressedReader.cc
  src/CompressedWriter.cc
  src/CPUIDBugDetector.cc
  src/DiversionSession.cc
  src/DumpCommand.cc
  src/EmuFs.cc
  src/Event.cc
  src/ExtraRegisters.cc
  src/Flags.cc
  src/GdbConnection.cc
  src/GdbServer.cc
  src/HelpCommand.cc
  src/kernel_abi.cc
  src/kernel_metadata.cc
  src/log.cc
  src/main.cc
  src/Monkeypatcher.cc
  src/PerfCounters.cc
  src/PsCommand.cc
  src/RecordCommand.cc
  src/RecordSession.cc
  src/record_signal.cc
  src/record_syscall.cc
  src/Registers.cc
  src/ReplayCommand.cc
  src/ReplaySession.cc
  src/replay_syscall.cc
  src/Scheduler.cc
  src/Session.cc
  src/task.cc
  src/TraceFrame.cc
  src/TraceStream.cc
  src/util.cc
)

target_link_libraries(rr
  -ldl
  -lrt
  -lz
)

target_link_libraries(rrpreload
  -ldl
)

install(PROGRAMS scripts/signal-rr-recording.sh
  DESTINATION bin)

install(TARGETS rr rrpreload
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)

# Build 32-bit librrpreload on 64-bit builds.
# We copy the source files into '32' subdirectories in the output
# directory, so we can set different compile options on them.
# This sucks but I can't find a better way to get CMake to build
# the same source file in two different ways.
if(rr_64BIT)
  foreach(file preload_interface.h traced_syscall_shared.S)
    set_source_files_properties(32/${file}
                                PROPERTIES GENERATED true HEADER_FILE_ONLY true)
    add_custom_command(OUTPUT 32/${file}
                       COMMAND cp "${CMAKE_CURRENT_SOURCE_DIR}/src/preload/${file}"
                                  "${CMAKE_CURRENT_BINARY_DIR}/32/${file}"
	               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/preload/${file}")
  endforeach(file)

  foreach(file preload.c traced_syscall.S untraced_syscall.S syscall_hook.S)
    set_source_files_properties(32/${file}
                                PROPERTIES GENERATED true COMPILE_FLAGS "-m32 -O2")
    add_custom_command(OUTPUT 32/${file}
                       COMMAND cp "${CMAKE_CURRENT_SOURCE_DIR}/src/preload/${file}"
                                  "${CMAKE_CURRENT_BINARY_DIR}/32/${file}"
	               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/preload/${file}"
                               32/preload_interface.h 32/traced_syscall_shared.S)
  endforeach(file)

  add_library(rrpreload_32
    32/preload.c
    32/traced_syscall.S
    32/untraced_syscall.S
    32/syscall_hook.S
  )
  set_target_properties(rrpreload_32 PROPERTIES LINK_FLAGS -m32)
  target_link_libraries(rrpreload_32
    -ldl
  )

  install(TARGETS rrpreload_32
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib)
endif()

##--------------------------------------------------
## Testing

# A "basic test" consists of a foo.c source file. All basic tests use the
# same basic_test.run driver script. The test name is passed as an additional
# parameter to the driver script. This script just does
# "compare_test EXIT-SUCCESS", i.e. records and replays the program and verifies
# that the output of both runs is identical and contains EXIT-SUCCESS.
#
# NB: you must update this variable when adding a new test source
# file.  The list is not generated automatically.
#
# Alphabetical, please.
set(BASIC_TESTS
  64bit_child
  accept
  alarm
  alarm2
  async_segv_ignored
  at_threadexit
  bad_ip
  bad_syscall
  barrier
  big_buffers
  block
  blocked_sigsegv
  chew_cpu
  clock
  clone
  constructor
  desched_blocking_poll
  epoll_create
  epoll_create1
  exec_self
  fadvise
  fault_in_code_page
  fcntl_owner_ex
  flock
  fork_child_crash
  fork_stress
  fxregs
  getgroups
  setitimer
  getsid
  gettimeofday
  grandchild_threads
  grandchild_threads_main_running
  grandchild_threads_thread_running
  grandchild_threads_parent_alive
  ignored_sigsegv
  int3
  intr_futex_wait_restart
  intr_poll
  intr_read_no_restart
  intr_read_restart
  intr_sleep
  intr_sleep_no_restart
  io
  legacy-ugid
  madvise
  map_fixed
  mmap_discontinuous
  mmap_private
  mmap_ro
  mmap_shared
  mmap_shared_subpage
  mmap_short_file
  mmap_tmpfs
  mprotect
  mprotect_heterogenous
  mprotect_stack
  mremap
  msg
  msync
  munmap_discontinuous
  no_mask_timeslice
  orphan_process
  pause
  perf_event
  poll_sig_race
  prctl
  prctl_name
  prw
  pthread_condvar_locking
  rdtsc
  readv
  rlimit
  rusage
  save_data_fd
  sched_setaffinity
  sched_yield
  sched_yield_to_lower_priority
  scm_rights
  sendfile
  setsid
  sigaction_old
  sigaltstack
  sigchld_interrupt_signal
  sigill
  signalfd
  sigprocmask
  sigqueueinfo
  sigreturn
  sigrt
  sigtrap
  simple
  sioc
  splice
  statfs
  strict_priorities
  switch_read
  syscallbuf_timeslice
  sysconf
  sysctl
  sysemu_singlestep
  sysinfo
  tcgets
  tgkill
  thread_stress
  timerfd
  times
  tiocgwinsz
  truncate
  uname
  unjoined_thread
  wait
  write_race
  writev
  zero_length_read
)

# A "test with program" consists of a foo.c source file and a foo.run driver
# script.  See src/test/util.sh to learn how the .run files work.
#
# NB: you must update this variable when adding a new test source
# file.  The list is not generated automatically.
#
# Alphabetical, please.
set(TESTS_WITH_PROGRAM
  abort_nonmain
  args
  async_kill_with_threads
  async_kill_with_threads_main_running
  async_kill_with_threads_thread_running
  async_segv
  async_signal_syscalls
  async_signal_syscalls_siginfo
  async_usr1
  block_intr_sigchld
  breakpoint
  breakpoint_overlap
  call_function
  condvar_stress
  crash
  exit_group
  exit_status
  explicit_checkpoints
  fork_syscalls
  getcwd
  goto_event
  hello
  ignored_async_usr1
  immediate_restart
  interrupt
  intr_ptrace_decline
  link
  mmap_write
  mutex_pi_stress
  nanosleep
  priority
  ptrace
  read_big_struct
  restart_abnormal_exit
  segfault
  step_thread
  target_fork
  target_process
  term_nonmain
  threaded_syscall_spam
  threads
  tiocinq
  user_ignore_sig
  vfork
  watchpoint
)

# A "test without program" is a foo.run driver script only, which does
# something with one of the test executables above (or has special rules
# to build its own executable).
#
# NB: you must update this variable when adding a new test source
# file.  The list is not generated automatically.
#
# Alphabetical, please.
set(TESTS_WITHOUT_PROGRAM
  async_signal_syscalls_100
  async_signal_syscalls_1000
  bad_breakpoint
  break_block
  break_clock
  break_clone
  break_exec
  break_int3
  break_mmap_private
  break_msg
  break_rdtsc
  break_sigreturn
  break_sync_signal
  break_thread
  break_time_slice
  call_exit
  checkpoint_async_signal_syscalls_1000
  checkpoint_mmap_shared
  checkpoint_prctl_name
  checkpoint_simple
  cont_signal
  cpuid
  dead_thread_target
  deliver_async_signal_during_syscalls
  env_newline
  execp
  explicit_checkpoint_clone
  fork_exec_info_thr
  get_thread_list
  hardlink_mmapped_files
  parent_no_break_child_bkpt
  parent_no_stop_child_crash
  read_bad_mem
  remove_watchpoint
  restart_unstable
  restart_diversion
  sanity
  signal_stop
  signal_checkpoint
  step1
  step_rdtsc
  step_signal
  subprocess_exit_ends_session
  syscallbuf_timeslice_250
  trace_version
  term_trace_cpu
  term_trace_syscall
)

foreach(test ${BASIC_TESTS} ${TESTS_WITH_PROGRAM})
  add_executable(${test} src/test/${test}.c)
  target_link_libraries(${test} -lrt)
endforeach(test)

add_library(test_lib
  src/test/test_lib.c
)

target_link_libraries(constructor -lrt test_lib)

# cpuid test needs to link with cpuid_loop.S
add_executable(cpuid src/test/cpuid.c src/test/cpuid_loop.S)
target_link_libraries(cpuid -lrt)

foreach(test ${BASIC_TESTS} ${OTHER_TESTS})
  add_test(${test}
    bash ${CMAKE_SOURCE_DIR}/src/test/basic_test.run -b ${PROJECT_BINARY_DIR} ${test})
  set_tests_properties(${test}
    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")

  add_test(${test}-no-syscallbuf
    bash ${CMAKE_SOURCE_DIR}/src/test/basic_test.run -n ${PROJECT_BINARY_DIR} ${test})
  set_tests_properties(${test}-no-syscallbuf
    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
endforeach(test)

foreach(test ${TESTS_WITH_PROGRAM} ${TESTS_WITHOUT_PROGRAM})
  add_test(${test}
    bash ${CMAKE_SOURCE_DIR}/src/test/${test}.run -b ${PROJECT_BINARY_DIR} ${test})
  set_tests_properties(${test}
    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")

  add_test(${test}-no-syscallbuf
    bash ${CMAKE_SOURCE_DIR}/src/test/${test}.run -n ${PROJECT_BINARY_DIR} ${test})
  set_tests_properties(${test}-no-syscallbuf
    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
endforeach(test)

# Run 32-bit tests on 64-bit builds.
# We copy the test files into '32' subdirectories in the output
# directory, so we can set different compile options on them.
# This sucks but I can't find a better way to get CMake to build
# the same source file in two different ways.
if(rr_64BIT)
  set_source_files_properties(32/rrutil.h
                              PROPERTIES GENERATED true HEADER_FILE_ONLY true)
  add_custom_command(OUTPUT 32/rrutil.h
                     COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/32 &&
                             mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/bin/32 &&

=== debian/changelog ===
rr (3.0.0-1) experimental; urgency=medium

  * New upstream release, adding 64-bit and Broadwell support, uploaded to
    experimental for the Jessie freeze.
  * Add test-tmpdir.patch to support TMPDIR values other than /tmp.
  * Enforce building with cmake.
  * Standards-Version 3.9.6, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 20 Dec 2014 18:05:05 +0100

=== debian/control ===
--- 
+++ 
@@ -6,19 +6,21 @@
  autotools-dev,
  cmake,
  debhelper (>= 9),
+ gcc-multilib,
  libdisasm-dev,
  libpfm4-dev,
+ python,
  zlib1g-dev,
 # The following are required for the test suite
 # python-pexpect,
 # realpath
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://rr-project.org
 Vcs-Git: git://anonscm.debian.org/collab-maint/rr.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/rr.git;a=summary
 
 Package: rr
-Architecture: i386
+Architecture: amd64 i386
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
@@ -31,4 +33,5 @@
  always identical from one run to another.
  .
  rr is incompatible with ptrace hardening, and currently only supports
- Intel Nehalem, Westmere, Sandy Bridge, Ivy Bridge and Haswell CPUs.
+ Intel Nehalem, Westmere, Sandy Bridge, Ivy Bridge, Haswell and
+ Broadwell CPUs.

=== debian/rules ===
--- 
+++ 
@@ -5,10 +5,6 @@
 #export DH_VERBOSE=1
 
 export DH_OPTIONS += -O-Bbuild
-
-override_dh_auto_configure:
-	rm -f configure
-	dh_auto_configure
 
 override_dh_auto_test:
 # Tests are disabled since they only work on supported CPUs
@@ -19,4 +15,4 @@
 	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
 
 %:
-	dh $@  --with autotools-dev
+	dh $@ --with autotools-dev --buildsystem=cmake

## rr 3.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,14 +13,28 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 3)
-set(rr_VERSION_MINOR 0)
+set(rr_VERSION_MINOR 2)
 set(rr_VERSION_PATCH 0)
+
+add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -O0 -g3 -Wall -Werror -Wstrict-prototypes")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++0x -pthread -O0 -g3 -Wall -Werror")
 set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")
+
+# Check that a 32-bit cross-compile works. This is needed regardless
+# of whether the entire build is being built 32-bit.
+if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64")
+  # try_compile won't accept LINK_FLAGS, so do this manually.
+  file(WRITE "${CMAKE_BINARY_DIR}/test32.c" "int main() { return 0; }")
+  execute_process(COMMAND ${CMAKE_CXX_COMPILER} -o ${CMAKE_BINARY_DIR}/test32 ${CMAKE_BINARY_DIR}/test32.c -m32
+			RESULT_VARIABLE COMPILER_32BIT_RESULT)
+  if(NOT (COMPILER_32BIT_RESULT EQUAL 0))
+    message(FATAL_ERROR "Your toolchain doesn't support 32-bit cross-compilation.")
+  endif()
+endif()
 
 option(force32bit, "Force a 32-bit build, rather than a 64-bit one")
 if(force32bit)
@@ -39,6 +53,57 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${rr_MBITNESS_OPTION}")
 set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} ${rr_MBITNESS_OPTION}")
 
+find_package(PkgConfig REQUIRED)
+
+# If we're cross-compiling a 32-bit build on a 64-bit host we need
+# to ensure we're looking for the right libraries.
+# This has been tested on Ubuntu and Fedora.
+set(LIBDIR32_CANDIDATES
+  /usr/lib/i386-linux-gnu/pkgconfig/
+  /usr/lib/pkgconfig/
+)
+if((NOT rr_64BIT) AND CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64")
+  foreach(libdir ${LIBDIR32_CANDIDATES})
+    if(IS_DIRECTORY ${libdir})
+      set(ENV{PKG_CONFIG_LIBDIR} ${libdir})
+      break()
+     endif()
+   endforeach(libdir)
+   if (NOT DEFINED ENV{PKG_CONFIG_LIBDIR})
+     message(FATAL_ERROR "Couldn't find a suitable 32-bit pkgconfig lib dir. You probably need to install a 32-bit pkgconfig package (pkgconfig.i686 for Fedora or pkg-config:i386 for Ubuntu")
+   endif()
+endif()
+
+# Check for required libraries
+set(REQUIRED_LIBS
+  zlib
+)
+foreach(required_lib ${REQUIRED_LIBS})
+  string(TOUPPER ${required_lib} PKG)
+  pkg_check_modules(${PKG} REQUIRED ${required_lib})
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${${PKG}_CFLAGS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PKG}_CFLAGS}")
+endforeach(required_lib)
+
+# Check for Python >=2.7 but not Python 3.
+find_package(PythonInterp 2.7 REQUIRED)
+if(PYTHON_VERSION_MAJOR GREATER 2)
+  message(FATAL_ERROR "Python 3 is not supported, please use Python 2.7.")
+endif()
+
+# Check for required Python modules
+set(REQUIRED_PYTHON_MODULES
+  pexpect
+)
+foreach(py_module ${REQUIRED_PYTHON_MODULES})
+  execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c"
+			"import ${py_module}"
+			RESULT_VARIABLE module_status)
+  if(module_status)
+    message(FATAL_ERROR "Couldn't find required Python module ${py_module}.")
+  endif()
+endforeach(py_module)
+
 set_source_files_properties(src/preload/preload.c PROPERTIES COMPILE_FLAGS -O2)
 
 include_directories("${PROJECT_SOURCE_DIR}/include")
@@ -62,6 +127,8 @@
   SyscallDefsTable.generated
   SyscallEnumsX64.generated
   SyscallEnumsX86.generated
+  SyscallEnumsForTestsX64.generated
+  SyscallEnumsForTestsX86.generated
   SyscallHelperFunctions.generated
   SyscallnameArch.generated
   SyscallRecordCase.generated
@@ -71,15 +138,16 @@
   set_source_files_properties(${generated_file}
                               PROPERTIES GENERATED true HEADER_FILE_ONLY true)
   add_custom_command(OUTPUT ${generated_file}
-                     COMMAND python "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
+                     COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
 		               "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
 		     DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
 		       "${CMAKE_CURRENT_SOURCE_DIR}/src/syscalls.py"
 		       "${CMAKE_CURRENT_SOURCE_DIR}/src/assembly_templates.py")
 endforeach(generated_file)
 
+add_custom_target(Generated DEPENDS ${GENERATED_FILES})
+
 add_executable(rr
-  ${GENERATED_FILES}
   src/test/cpuid_loop.S
   src/AddressSpace.cc
   src/AutoRemoteSyscalls.cc
@@ -92,6 +160,8 @@
   src/EmuFs.cc
   src/Event.cc
   src/ExtraRegisters.cc
+  src/fast_forward.cc
+  src/FdTable.cc
   src/Flags.cc
   src/GdbConnection.cc
   src/GdbServer.cc
@@ -99,6 +169,7 @@
   src/kernel_abi.cc
   src/kernel_metadata.cc
   src/log.cc
+  src/MagicSaveDataMonitor.cc
   src/main.cc
   src/Monkeypatcher.cc
   src/PerfCounters.cc
@@ -111,18 +182,21 @@
   src/ReplayCommand.cc
   src/ReplaySession.cc
   src/replay_syscall.cc
+  src/ReplayTimeline.cc
   src/Scheduler.cc
   src/Session.cc
+  src/StdioMonitor.cc
   src/task.cc
   src/TraceFrame.cc
   src/TraceStream.cc
   src/util.cc
 )
+add_dependencies(rr Generated)
 
 target_link_libraries(rr
   -ldl
   -lrt
-  -lz
+  ${ZLIB_LDFLAGS}
 )
 
 target_link_libraries(rrpreload
@@ -198,6 +272,7 @@
   alarm
   alarm2
   async_segv_ignored
+  async_signal_syscalls2
   at_threadexit
   bad_ip
   bad_syscall
@@ -205,11 +280,16 @@
   big_buffers
   block
   blocked_sigsegv
+  brk
   chew_cpu
+  chown
   clock
   clone
+  clone_bad_stack
+  clone_untraced
   constructor
   desched_blocking_poll
+  dup
   epoll_create
   epoll_create1
   exec_self
@@ -221,6 +301,7 @@
   fork_stress
   fxregs
   getgroups
+  getrandom
   setitimer
   getsid
   gettimeofday
@@ -232,14 +313,17 @@
   int3
   intr_futex_wait_restart
   intr_poll
+  intr_pselect
   intr_read_no_restart
   intr_read_restart
   intr_sleep
   intr_sleep_no_restart
+  invalid_fcntl
   io
-  legacy-ugid
+  legacy_ugid
   madvise
   map_fixed
+  mincore
   mmap_discontinuous
   mmap_private
   mmap_ro
@@ -253,17 +337,35 @@
   mremap
   msg
   msync
+  multiple_pending_signals
+  multiple_pending_signals_sequential
+  munmap_segv
   munmap_discontinuous
   no_mask_timeslice
+  numa
+  old_fork
   orphan_process
   pause
   perf_event
   poll_sig_race
   prctl
+  prctl_deathsig
   prctl_name
   prw
   pthread_condvar_locking
+  ptrace
+  ptrace_attach_null_status
+  ptrace_attach_running
+  ptrace_attach_sleeping
+  ptrace_attach_stopped
+  ptrace_attach_thread_running
+  ptracer_death
+  ptracer_death_multithread
+  ptracer_death_multithread_peer
+  quotactl
   rdtsc
+  readdir
+  readlink
   readv
   rlimit
   rusage
@@ -272,25 +374,41 @@
   sched_yield
   sched_yield_to_lower_priority
   scm_rights
+  seccomp
+  seccomp_null
+  sem
   sendfile
+  set_ptracer
   setsid
+  shm
   sigaction_old
   sigaltstack
   sigchld_interrupt_signal
+  sighandler_fork
   sigill
   signalfd
   sigprocmask
   sigqueueinfo
   sigreturn
+  sigreturn_reg
   sigrt
+  sigstop
+  sigstop2
+  sigsuspend
   sigtrap
   simple
   sioc
+  sock_names_opts
   splice
   statfs
+  stdout_child
+  stdout_cloexec
+  stdout_dup
+  stdout_redirect
   strict_priorities
   switch_read
   syscallbuf_timeslice
+  syscallbuf_timeslice2
   sysconf
   sysctl
   sysemu_singlestep
@@ -302,11 +420,17 @@
   times
   tiocgwinsz
   truncate
+  tty_ioctls
   uname
   unjoined_thread
+  unshare
+  utimes
+  vfork_flush
+  video_capture
   wait
   write_race
   writev
+  xattr
   zero_length_read
 )
 
@@ -328,148 +452,21 @@
   async_signal_syscalls_siginfo
   async_usr1
   block_intr_sigchld
+  blocked_bad_ip
   breakpoint
   breakpoint_overlap
   call_function
+  checkpoint_dying_threads
+  clone_interruption
+  conditional_breakpoint_calls
   condvar_stress
   crash
   exit_group
   exit_status
   explicit_checkpoints
   fork_syscalls
+  function_calls
   getcwd
   goto_event
   hello
   ignored_async_usr1
-  immediate_restart
-  interrupt
-  intr_ptrace_decline
-  link
-  mmap_write
-  mutex_pi_stress
-  nanosleep
-  priority
-  ptrace
-  read_big_struct
-  restart_abnormal_exit
-  segfault
-  step_thread
-  target_fork
-  target_process
-  term_nonmain
-  threaded_syscall_spam
-  threads
-  tiocinq
-  user_ignore_sig
-  vfork
-  watchpoint
-)
-
-# A "test without program" is a foo.run driver script only, which does
-# something with one of the test executables above (or has special rules
-# to build its own executable).
-#
-# NB: you must update this variable when adding a new test source
-# file.  The list is not generated automatically.
-#
-# Alphabetical, please.
-set(TESTS_WITHOUT_PROGRAM
-  async_signal_syscalls_100
-  async_signal_syscalls_1000
-  bad_breakpoint
-  break_block
-  break_clock
-  break_clone
-  break_exec
-  break_int3
-  break_mmap_private
-  break_msg
-  break_rdtsc
-  break_sigreturn
-  break_sync_signal
-  break_thread
-  break_time_slice
-  call_exit
-  checkpoint_async_signal_syscalls_1000
-  checkpoint_mmap_shared
-  checkpoint_prctl_name
-  checkpoint_simple
-  cont_signal
-  cpuid
-  dead_thread_target
-  deliver_async_signal_during_syscalls
-  env_newline
-  execp
-  explicit_checkpoint_clone
-  fork_exec_info_thr
-  get_thread_list
-  hardlink_mmapped_files
-  parent_no_break_child_bkpt
-  parent_no_stop_child_crash
-  read_bad_mem
-  remove_watchpoint
-  restart_unstable
-  restart_diversion
-  sanity
-  signal_stop
-  signal_checkpoint
-  step1
-  step_rdtsc
-  step_signal
-  subprocess_exit_ends_session
-  syscallbuf_timeslice_250
-  trace_version
-  term_trace_cpu
-  term_trace_syscall
-)
-
-foreach(test ${BASIC_TESTS} ${TESTS_WITH_PROGRAM})
-  add_executable(${test} src/test/${test}.c)
-  target_link_libraries(${test} -lrt)
-endforeach(test)
-
-add_library(test_lib
-  src/test/test_lib.c
-)
-
-target_link_libraries(constructor -lrt test_lib)
-
-# cpuid test needs to link with cpuid_loop.S
-add_executable(cpuid src/test/cpuid.c src/test/cpuid_loop.S)
-target_link_libraries(cpuid -lrt)
-
-foreach(test ${BASIC_TESTS} ${OTHER_TESTS})
-  add_test(${test}
-    bash ${CMAKE_SOURCE_DIR}/src/test/basic_test.run -b ${PROJECT_BINARY_DIR} ${test})
-  set_tests_properties(${test}
-    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
-
-  add_test(${test}-no-syscallbuf
-    bash ${CMAKE_SOURCE_DIR}/src/test/basic_test.run -n ${PROJECT_BINARY_DIR} ${test})
-  set_tests_properties(${test}-no-syscallbuf
-    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
-endforeach(test)
-
-foreach(test ${TESTS_WITH_PROGRAM} ${TESTS_WITHOUT_PROGRAM})
-  add_test(${test}
-    bash ${CMAKE_SOURCE_DIR}/src/test/${test}.run -b ${PROJECT_BINARY_DIR} ${test})
-  set_tests_properties(${test}
-    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
-
-  add_test(${test}-no-syscallbuf
-    bash ${CMAKE_SOURCE_DIR}/src/test/${test}.run -n ${PROJECT_BINARY_DIR} ${test})
-  set_tests_properties(${test}-no-syscallbuf
-    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
-endforeach(test)
-
-# Run 32-bit tests on 64-bit builds.
-# We copy the test files into '32' subdirectories in the output
-# directory, so we can set different compile options on them.
-# This sucks but I can't find a better way to get CMake to build
-# the same source file in two different ways.
-if(rr_64BIT)
-  set_source_files_properties(32/rrutil.h
-                              PROPERTIES GENERATED true HEADER_FILE_ONLY true)
-  add_custom_command(OUTPUT 32/rrutil.h
-                     COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/32 &&
-                             mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/bin/32 &&

=== debian/changelog ===
rr (3.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 29 Apr 2015 20:32:57 +0200

rr (3.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop test-tmpdir.patch, merged upstream.
  * Refresh move-librrpreload.patch.
  * g++-multilib, pkg-config and python-pexpect are now required.
  * setup.sh is no longer provided.

 -- Stephen Kitt <skitt@debian.org>  Sun, 26 Apr 2015 14:56:01 +0200

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,14 @@
  autotools-dev,
  cmake,
  debhelper (>= 9),
- gcc-multilib,
+ g++-multilib,
  libdisasm-dev,
  libpfm4-dev,
+ pkg-config,
  python,
+ python-pexpect,
  zlib1g-dev,
 # The following are required for the test suite
-# python-pexpect,
 # realpath
 Standards-Version: 3.9.6
 Homepage: http://rr-project.org
